Subject: Re: [bug#68163] [PATCH] gnu: Prevent stale cache use when `%package-module-path' is parameterized.

From: antlers <[email-masked]>
Date: Wed, 17 Jan 2024 00:32:39 -0800

Updates:

> I don't know if a.) there's any cause to be concerned about the
> performance of this tweak, or b.) that you care to support the
> behavior at all, but I hope I've made my own use-case clear and the
> patch is there if you see fit c:

a.) I glued hyperfine to a pair of guix repl endpoints, scaled up until I hit segfaults, no difference
b.) Maybe `specification->package' just has some particular notion of what's "current", like "current-channels" does, in which case we can rule out complacence with the parameter as a non-feature-- but I certainly isn't the same notion.
c.) I had the bright idea to set GUIX_PACKAGE_PATH at build time, first on the command-line and then in the channel modules, but it didn't work out-- felt silly for a minute there. Hey, how do third party channels usually resolve `search-path'? Isn't that the same thing, packages and patches in the same repo? Or are they just expected to use `local-file' and relative paths? I'll look into this another time.

If B or C had come to fruition I'd have closed the issue with 'em, and something like B is up for interpretation-- I don't mind either way (happy to carry the patch on my own). But if I enjoy these instances of syntax-sugar in my own channels (which I do :p), and if the Guix repo utilizes + is cleaner for them as well, then I figure it'd be a shame (barring a solution like C) to interpret the implementation as one which excludes other channels.